/*Hier solution to the BLM problem
 *
 * vamsik@engr.uconn.edu
 **/
#ifndef __BLM_HIER_H
#define __BLM_HIER_H
#define PROBE_WIDTH 10
extern unsigned long PDIM;
/*global distance table (i.e. GDT[i][j] = hamming(i,j)*/
extern unsigned long **GDT; 
/*compute the cost of the permutation*/
typedef struct __sub_problem__{
/*The indices of the probes in the group*/
	unsigned int *probes; 
/*The length of the probes, this should be
 *obvious from level*/
 	unsigned int psize;
/*Just for referring the probe */
	unsigned long sid; 
/*Level of the sup-problem in the tree*/
	unsigned long level; 
/*Best permutation till now*/
	int *best_perm;
/*Best cost*/
	unsigned long best_cost;
/*Subproblem distance matrix $PDIM\times PDIM$*/
/*SUB_DIST_TABLEl(i,j,o) $o\in\{h,v\}$ */
	unsigned long *SUB_DIST_TABLE;
}SubProblem;

typedef unsigned long (*SubProblemCost)(int *perm, SubProblem *);
#endif

